// ignore_for_file: avoid_print

import 'dart:io';
import 'package:http/http.dart' as http;

Future<void> main(List<String> args) async {
  var response = await http.get(
    Uri.parse(
      'https://raw.githubusercontent.com/ez-connect/flutter-ionicons/main/lib/ionicons.dart',
    ),
  );

  var body = response.body;

  var lines = body.split('\n');

  var regex = RegExp(r'IconData (?<icon>\S*) = IoniconsData');

  var file = File('lib/ionicons_named.dart');
  var data = '''
// AUTOGENERATED FILE; DO NOT EDIT

import 'package:ionicons/ionicons.dart';

const ionicons = {
''';

  var icons = <String>[];
  for (var line in lines) {
    if (regex.hasMatch(line)) {
      var match = regex.firstMatch(line)!;

      var icon = match.namedGroup('icon')!;

      print(icon);

      icons.add(icon);
    }
  }

  icons.sort();
  for (var icon in icons) {
    data += "'$icon': Ionicons.$icon,\n";
  }

  data += '\n};';

  if (file.existsSync()) {
    file.deleteSync(recursive: true);
  }
  file.createSync(recursive: true);
  file.writeAsStringSync(data);

  print('');
  print('Generated: ${file.absolute.path}');
  print('Formatting...');
  await Process.runSync('dart', ['format', 'lib']);

  print('');
  print('DONE!');
}
